'use strict';
const email = require('emailjs');
const toText = require('html2plaintext');

module.exports = (serverConfig = {}) => {

    async function send(config, html) {
        if (!config.from)
            throw new Error("must send with a from: parameter");
        if (!config.to)
            throw new Error("must send with a to: parameter");
        
        var html = String(html);
        const server = email.server.connect(serverConfig);
        const message = {
            ...config,
            text: toText(html),
            attachment: [
                {data: html, alternative: true},
            ],
        };
        
        // Send the message and await completion. Return
        // the details of the sent message.
        return await new Promise((resolve, reject) => {
            server.send(message, (err, message) => {
                if (err)
                    reject(err);
                else
                    resolve(message);
            });
        });
    }

    return send;
};
